unit Unit1;

{$mode delphi}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, BCMaterialDesignButton,
  Blocks, CButtons;

type

  { TForm2 }

  TForm2 = class(TForm)
    B_ColChange: TBCMaterialDesignButton;
    ColorDialog1: TColorDialog;
    procedure B_ColChangeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);


    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
  private
    procedure DrawText(X, Y: integer; point: Tpoint; Canvas: TCanvas);
    procedure drawGrid(aControl: TCustomControl);
    { Private-Deklarationen }

  public
    { Public-Deklarationen }




    bCol: TColor;
  end;

var
  Form2: TForm2;
  myBlock: TBlock;

implementation

{$R *.lfm}



procedure TForm2.drawGrid(aControl: TCustomControl);
var
  i, X, Y: integer;
begin

  { Draw a grid }
  X := 0;
  Y := 0;

  with aControl.Canvas do
  begin
    Pen.Color := RGBToColor(50, 50, 50);
    Pen.Width := 2;
    for i := 0 to Pred(10) do
    begin
      MoveTo(X, 0);
      LineTo(X, aControl.Height);
      X := X + (aControl.Width div 10);
    end;

    for i := 0 to Pred(10) do
    begin
      MoveTo(0, Y);
      LineTo(aControl.Width, Y);
      Y := Y + (aControl.Height div 10);
    end;
  end;

end;




procedure TForm2.DrawText(X, Y: integer; point: Tpoint; Canvas: TCanvas);

begin

  Canvas.Brush.Style := bsClear;
  Canvas.Font.Size := 16;
  Canvas.Font.Name := 'Arial';
  Canvas.Font.Orientation := -900;
  Canvas.Font.Color := RGBToColor(100, 100, 100);
  Canvas.TextOut(X + 30, Y - 75, 'X: ' + point.X.ToString + ' Y: ' + point.y.ToString);
  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Color := bCol;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  bCol := rgbtocolor(246, 7, 142);

  myBlock := TBlock.Create(Form2.Canvas);
  myBlock.Color := bCol;
  Canvas.Brush.Color := bCol;
  Form2.Color := rgbtocolor(64, 64, 64);

end;

procedure TForm2.B_ColChangeClick(Sender: TObject);
begin
  ColorDialog1.Color := myBlock.Color;

  ColorDialog1.Execute;
  myBlock.Color := ColorDialog1.Color;
  B_ColChange.NormalColorEffect := ColorDialog1.Color;
end;

procedure TForm2.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  myBlock.MouseTouch(X, Y);

end;

procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
begin
  myBlock.Move(X, Y);
  Repaint;

end;

procedure TForm2.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  myBlock.isTouching := False;

end;

procedure TForm2.FormPaint(Sender: TObject);
begin
  drawGrid(Form2);
  DrawText(Width - 50, Height div 2, myBlock.Location, Canvas);

  myBlock.Draw(Form2.Canvas);

end;

end.
